%% Binary resolution.  DM is trying to do this subset of resolution in
%% order to see how well the material in the draft paper works on
%% this case.  I think I've designed the certificate definition
%% correctly.  Now I'm in the process of debugging it.

module binary-harness.
accumulate lkf-kernel.  
accumulate binary-fpc. 

% Conversion from convenient logic syntax to lku formulas.
nnf (p X) L :- lit+2 (pp X) L.
nnf (q X) L :- lit+2 (qq X) L.
nnf r L :- lit+2 rr L.
nnf s L :- lit+2 ss L.
nnf (ng (p X)) L :- lit-2 (pp X) L.
nnf (ng (q X)) L :- lit-2 (qq X) L.
nnf (ng r) L :- lit-2 rr L.
nnf (ng s) L :- lit-2 ss L.
nnf ttrue  A :- true+2 A.
nnf ffalse A :- false-2 A.
nnf (and B C)   A :- nnf B D, nnf C E, conj+2 D E A.
nnf (or  B C)   A :- nnf B D, nnf C E, disj-2 D E A.
nnf (imp B C)   A :- nnf (ng B) D, nnf C E, disj-2 D E A.
nnf (equiv B C) A :- nnf (imp B C) D, nnf (imp C B) E, conj+2 D E A.
nnf (all B)     A :- (pi x\ nnf (B x) (C x)), all-2 C A.
nnf (some B)    A :- (pi x\ nnf (B x) (C x)), some+2 C A.
nnf (ng ttrue)  A :- false-2 A.
nnf (ng ffalse) A :- true+2 A.
nnf (ng (ng B)) C :- nnf B C.
nnf (ng (and B C)) A   :- nnf (ng B) D, nnf (ng C) E, disj-2 D E A.
nnf (ng (or  B C)) A   :- nnf (ng B) D, nnf (ng C) E, conj+2 D E A.
nnf (ng (imp B C)) A   :- nnf B D,      nnf (ng C) E, conj+2 D E A.
nnf (ng (equiv B C)) A :- nnf (ng (imp B C)) D, nnf (ng (imp C B)) E, 
			disj-2 D E A.
nnf (ng (all B))  A :- (pi x\ nnf (ng (B x)) (C x)), some+2 C A.
nnf (ng (some B)) A :- (pi x\ nnf (ng (B x)) (C x)), all-2  C A.

print_clause I S  :- print "nclause ",
                     term_to_string I Istr, print Istr, print " = ", 
                     term_to_string S Sstr, print Sstr, print "\n".

% cloop Index Org Clauses Goal
%   Index is the index that counts from 1 up; Org is the index of the last
%   clause in the orginal collection; Clauses are *all* clauses in the 
%   certificate (the first Org are original, the remaining are simply named), 
%   and Goal is the continuation once these clauses are loaded.

cloop I Org []     G :- I <= Org, print "Warning: too few clauses.\n", !, fail.
cloop I Org []     G :- G.
cloop I Org [C|Cs] G :-
   nnf (ng C) NC', ensure+2 NC' NC,
   print_clause I NC, I' is (I + 1), 
   ref (idx I) NC => 
      (I <= Org, (czone (idx I) => cloop I' Org Cs G) ;
       I >  Org,                   cloop I' Org Cs G).

resolve N _ Clauses Rs :- 
              nnf ffalse False, end_sequent False Seq,
              cloop 1 N Clauses (asyncTac (rlist Rs) Seq).

