module cnf-harness.
accumulate lkf-kernel.  
accumulate cnf-fpc. 

% Conversion from propositional logic syntax to lku formulas.
nnf p L :- lit+2 pp L.
nnf q L :- lit+2 qq L.
nnf r L :- lit+2 rr L.
nnf s L :- lit+2 ss L.
nnf (ng p) L :- lit-2 pp L.
nnf (ng q) L :- lit-2 qq L.
nnf (ng r) L :- lit-2 rr L.
nnf (ng s) L :- lit-2 ss L.
nnf (and B C)   A :- nnf B D, nnf C E, conj-2 D E A.
nnf (or  B C)   A :- nnf B D, nnf C E, disj-2 D E A.
nnf (imp B C)   A :- nnf (ng B) D, nnf C E, disj-2 D E A.
nnf (equiv B C) A :- nnf (imp B C) D, nnf (imp C B) E, conj-2 D E A.
nnf (ng (ng B)) C :- nnf B C.
nnf (ng (and B C)) A   :- nnf (ng B) D, nnf (ng C) E, disj-2 D E A.
nnf (ng (or  B C)) A   :- nnf (ng B) D, nnf (ng C) E, conj-2 D E A.
nnf (ng (imp B C)) A   :- nnf B D,      nnf (ng C) E, conj-2 D E A.
nnf (ng (equiv B C)) A :- nnf (ng (imp B C)) D, nnf (ng (imp C B)) E, disj-2 D E A.

% Apply the cnf-fpc certificate definition to a proposed tautology.
check_tautology B :- end_sequent B Seq, asyncTac dec_cnf Seq.

