sig lkuForm.
% Encoding the formulas of LKU: see Liang & Miller, APAL 2011.


% First-order formulas and atoms
kind form, atm         type.

% predicates for constructing and deconstructing formulas
type conj+1, conj+2, conj-1, conj-2           form -> form -> form -> o.
type disj+1, disj+2, disj-1, disj-2           form -> form -> form -> o.
type lit-1, lit-2, lit+1, lit+2                        atm -> form -> o.
type all-1, all-2, some+1, some+2              (A -> form) -> form -> o.
type true+1,  true+2,  true-1,  true-2,
     false+1, false+2, false-1, false-2                       form -> o.

% some useful, derived deconstructors
type conj-, conj+, disj-, disj+               form -> form -> form -> o.
type true-, true+, false-, false+                             form -> o.
type all-, some+                               (A -> form) -> form -> o.

% predicates for testing their arguments 
type pos_lit, pos1_lit, pos2_lit      form -> o.
type neg_lit, neg1_lit, neg2_lit      form -> o.
type pos1_form, pos2_form             form -> o.
type neg1_form, neg2_form             form -> o.
type isNeg, isPos, litOrPos           form -> o.
type composed_form		      form -> o.

% compute the de Morgan dual of a formula
type negate                   form -> form -> o.

% TODO: explain what those predicates do
type ensure-1, ensure-2, ensure+1, ensure+2     form -> form -> o.


