module msets.

% The declarations of locally declared predicates.

type ms           	list A -> mset A.
type select_aux        	A -> list A -> list A -> o.
type mseteq_aux         list A -> list A -> o.
type split_aux        	list A -> list A -> list A -> o.
type mset_eq_aux 	list A -> list A -> o.

mset_empty (ms nil).

mset_singleton C (ms (C::nil)).

mset_eq (ms L) (ms K) :- mset_eq_aux L K.
mset_eq_aux nil nil.
mset_eq_aux (X::L) K :- select_aux X K K', mset_eq_aux L' K'.

mset_add    X (ms L) (ms (X::L)).
mset_select X (ms L) (ms K):- select_aux X L K.

select_aux X (X::L) L.
select_aux X (Y::L) (Y::K) :- select_aux X L K.

mset_split (ms L) (ms K) (ms M) :- split_aux L K M.

split_aux nil nil nil.
split_aux (X::L) (X::K) M :- split_aux L K M.
split_aux (X::L) K (X::M) :- split_aux L K M.

mset_split_filter _ _ (ms nil) (ms nil) (ms nil).
mset_split_filter F G (ms (X::L)) (ms (X::K)) M :- 
	F X, mset_split_filter F G (ms L) (ms K) M.
mset_split_filter F G (ms (X::L)) K (ms (X::M)) :- 
	G X, mset_split_filter F G (ms L) K (ms M).
