sig stlc-fpc.
accum_sig lists, ljf-kernel, stlc.
accum_sig stlc-harness. /* Used by the type translation in the cut expert */



/* For each formula in the classical zone, we have an index */
type c_idx			int -> index.
/* This is the special case for extra arguments involved in an eta redex */
type x_idx			int -> index.
/* As we never decide on negative literals, we don't need to distinguish them */
type l_idx			index.
/*  To decide on delayed formulas
  We store the formula under its own name since doing so we avoid 
  having an extra argument to remember the index (and we can retrieve it as
  it is the only formula present in the linear context) */
type d_idx			form -> index.


/* Usual certificate with wich we start */
type st_term_cert
				db_term ->  	/* The lambda term */
				int -> 		/* The depth */
				int ->		/* Counter for extra args*/
				list int -> 	/* Extra args */
				cert.

/* We switch to this certificate when we process the arguments of a variable */
type st_args_cert
				list db_term -> /* The list of arguments */
				int -> 		/* The depth */
				int ->		/* Counter for extra args */
				list int -> 	/* Extra args */
				cert.

/* We switch to this certificate when there is only extra arguments
  from an eta redex to check */
type st_extra_cert	
				int -> 		/* Counter for extra args */
				list int -> 	/* Extra args */
				cert.


/* We switch to this certificate when there is no more information to give
  (only an asynchronous phase to finish) */
type st_empty_cert		cert.	


type not_redex			db_term -> o.
