module stlc-harness.
accumulate stlc-fpc, ljf-kernel.

/****************************/
/*         Embeddings       */
/****************************/

st_embed_form_r_lku (A st_arr B) C :-
        st_embed_form_l_lku A A', 
        st_embed_form_r_lku B B',
	/* Add a positive delay */
	true+2 T,
	conj+2 T B' B'',	
	disj-1 A' B'' C.
	
st_embed_form_r_lku (all_ty F) T :-
	pi x\ st_embed_form_r_lku (F x) (F' x),
	all-1 F' T.
	
st_embed_form_r_lku (st_atm I) L :- lit-1 (gt I) L.
st_embed_form_r_lku (basicType I) L :- lit-1 I L.


st_embed_form_l_lku (A st_arr B) C :-
        st_embed_form_r_lku A A', 
        st_embed_form_l_lku B B',
	conj+1 A' B' C. 
	
st_embed_form_l_lku (all_ty F) T :-
	pi x\ st_embed_form_l_lku (F x) (F' x),
	some+1 F' T.
	
st_embed_form_l_lku (st_atm I) L :- lit+1 (gt I) L.
st_embed_form_l_lku (basicType I) L :- lit+1 I L.





embed_and_check Term Type :-
	/* Embed the type as a formula */
	sigma Form\ (st_embed_form_r_lku Type Form),
	/* Embed the formula in a sequent */
	end_sequent Form Seq, 
	/* Initialize depth and counter to 0, extra arguments to an empty 
	  list, and check the sequent */
	asyncTac (st_term_cert Term 0 0 []) Seq, 
	/* TODO: investigate why there are so many proofs without a cut */
	!.

